Controllers/Student/StudentComplainsController.cs
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.Entity;
using System.IO;
using System.Linq;
using System.Net;
using System.Web;
using System.Web.Mvc;
using LabMaintanance6.Models;
using System.Net.Mail;
using System.Web.UI;
using PagedList;
using PagedList.Mvc;

namespace LabMaintanance6.Controllers.Student
{
    public class StudentComplainsController : Controller
    {
        private LabMaintanance4Entities db = new LabMaintanance4Entities();

        // GET: StudentComplains
        public ActionResult Index(int? i)
        {
            // Retrieve user ID from session
            int? userId = Session["UserId"] as int?;
            // Retrieve role ID from session
            int? roleId = Session["RoleId"] as int?;

            // Perform authorization logic using the session's UserId and RoleId
            if (userId == null || roleId != 3)
            {
                // Authorization failed, redirect to Home/Index
                return RedirectToAction("Index", "Home");
            }

            var complains1 = db.Complains
                .Where(c => c.status)
                .Include(c => c.AllUser)
                .Include(c => c.Priority)
                .Include(c => c.Repaired_Staus)

                .OrderByDescending(c => c.complain_id) // Order by a specific property, such as Id
                .ToList()
                .ToPagedList(i ?? 1, 3);




            return View(complains1);
        }

        // GET: StudentComplains/Details/5
        public ActionResult Details(int? id)
        {
            // Retrieve user ID from session
            int? userId = Session["UserId"] as int?;
            // Retrieve role ID from session
            int? roleId = Session["RoleId"] as int?;

            // Perform authorization logic using the session's UserId and RoleId
            if (userId == null || roleId != 3)
            {
                // Authorization failed, redirect to Home/Index
                return RedirectToAction("Index", "Home");
            }

            if (id == null)
            {
                return new HttpStatusCodeResult(HttpStatusCode.BadRequest);
            }
            Complain complain1 = db.Complains.Find(id);
            if (complain1 == null)
            {
                return HttpNotFound();
            }
            return View(complain1);
        }

        // GET: Complains/Create
        public ActionResult Create()
        {
            // Retrieve user ID from session
            int? userId = Session["UserId"] as int?;
            // Retrieve role ID from session
            int? roleId = Session["RoleId"] as int?;

            // Perform authorization logic using the session's UserId and RoleId
            if (userId == null || roleId != 3)
            {
                // Authorization failed, redirect to Home/Index
                return RedirectToAction("Index", "Home");
            }

            ViewBag.user_id = userId;
            ViewBag.PriorityId = new SelectList(db.Priorities, "PriorityId", "priority1");
            ViewBag.Repaired_StausId = new SelectList(db.Repaired_Staus, "Repaired_StausId", "R_Status");
            return View();
        }

        // POST: Complains/Create
        // To protect from overposting attacks, enable the specific properties you want to bind to, for 
        // more details see https://go.microsoft.com/fwlink/?LinkId=317598.
        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult Create(Complain complain, HttpPostedFileBase imageData)
        {
            // Retrieve user ID from session
            int? userId = Session["UserId"] as int?;
            // Retrieve role ID from session
            int? roleId = Session["RoleId"] as int?;

            // Perform authorization logic using the session's UserId and RoleId
            if (userId == null || roleId != 3)
            {
                // Authorization failed, redirect to Home/Index
                return RedirectToAction("Index", "Home");
            }

            if (ModelState.IsValid)
            {
                if (imageData != null && imageData.ContentLength > 0)
                {
                    // Convert the uploaded image to a byte array
                    byte[] imageBytes;
                    using (var binaryReader = new BinaryReader(imageData.InputStream))
                    {
                        imageBytes = binaryReader.ReadBytes(imageData.ContentLength);
                    }

                    complain.image_data = imageBytes;
                }
                complain.user_id = userId.Value;
                complain.status = true;
                db.Complains.Add(complain);
                db.SaveChanges();

                // Get the list of users with role_id = 2
                var users = db.AllUsers.Where(u => u.role_id == 2 && u.status == true).ToList();

                // Send email to each user
                try
                {
                    foreach (var user in users)
                    {
                        SendEmail(user.email, "Labmaintanior", "A new complain has been created. Please review it.");
                    }

                    return RedirectToAction("Index");
                }
                catch (Exception ex)
                {
                    return RedirectToAction("Index");
                }
            }

            ViewBag.PriorityId = new SelectList(db.Priorities, "PriorityId", "priority1", complain.PriorityId);
            ViewBag.Repaired_StausId = new SelectList(db.Repaired_Staus, "Repaired_StausId", "R_Status", complain.Repaired_StausId);
            ViewBag.user_id = userId;
            return View(complain);
        }


        private void SendEmail(string recipient, string subject, string body)
        {
            // Configure the SMTP client
            var smtpClient = new SmtpClient("smtp.gmail.com", 587);
            smtpClient.EnableSsl = true;
            smtpClient.UseDefaultCredentials = false;
            smtpClient.Credentials = new NetworkCredential("soumaykanti2859@gmail.com", "ssatuysevdkgrthi");

            // Create the email message
            var message = new MailMessage();
            message.From = new MailAddress("soumaykanti2859@gmail.com");
            message.To.Add(new MailAddress(recipient));
            message.Subject = subject;
            message.Body = body;

            // Send the email
            smtpClient.Send(message);
        }







        protected override void Dispose(bool disposing)
        {
            if (disposing)
            {
                db.Dispose();
            }
            base.Dispose(disposing);
        }
    }
}

Views/StudentComplains/Create.cshtml
@model LabMaintanance6.Models.Complain

@{
    ViewBag.Title = "Create";
    Layout = "~/Views/Shared/User_layout.cshtml";
}

@section Scripts {
    @Scripts.Render("~/bundles/jqueryval")

    <script>
        // Function to get the current date and time in yyyy-MM-dd HH:mm format
        function getCurrentDateTime() {
            var today = new Date();
            var year = today.getFullYear();
            var month = String(today.getMonth() + 1).padStart(2, '0');
            var day = String(today.getDate()).padStart(2, '0');
            var hours = String(today.getHours()).padStart(2, '0');
            var minutes = String(today.getMinutes()).padStart(2, '0');
            var dateTime = year + '-' + month + '-' + day + ' ' + hours + ':' + minutes;
            return dateTime;
        }

        // Set the current date and time in the action_date field
        $(document).ready(function () {
            var currentDateTime = getCurrentDateTime();
            $('#action_date').val(currentDateTime);
        });
    </script>
}
<!DOCTYPE html>
<html>
<head>
    <title>Create Complaint</title>
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css" integrity="sha384-B4gt1jrGC7Jh4AgTPSdUtOBvfO8sh+WyqDz5SvLmbehY4p6o7aS7iC5f1l/2kCS" crossorigin="anonymous">
    <style>
        /* Additional CSS styles for fields */
        label {
            font-weight: bold;
        }

        select,
        input[type="text"],
        textarea {
            width: 100%;
            padding: 8px;
            border: 1px solid #ccc;
            border-radius: 4px;
            box-sizing: border-box;
            font-size: 14px;
            margin-bottom: 10px;
        }

        select {
            height: 34px;
        }

        textarea {
            resize: vertical;
        }

        .text-danger {
            color: red;
        }
    </style>
</head>
<body>
 
    <div class="container mt-5">
        <div class="row justify-content-center">
            <div class="col-md-8 col-sm-10">


                @using (Html.BeginForm("Create", "StudentComplains", FormMethod.Post, new { enctype = "multipart/form-data" }))
                {
                    @Html.AntiForgeryToken()

                    <table class="table table-striped">
                        <thead class="thead-light">
                            <tr>   <h2 class="text-center mb-4">Please Submit Your Complaint Here</h2></tr>
                            <tr>
                                <th>Field</th>
                                <th>Value</th>
                            </tr>
                        </thead>
                        <tbody>
                            <tr>
                                <th>Name_of_the_Item</th>
                                <td>
                                    @Html.EditorFor(model => model.Name_Of_the_Item, new { htmlAttributes = new { @class = "form-control", required = "required" } })
                                    @Html.ValidationMessageFor(model => model.Name_Of_the_Item, "", new { @class = "text-danger" })
                                </td>
                            </tr>
                            <tr>
                                <th>Description</th>
                                <td>
                                    @Html.TextAreaFor(model => model.description, new { @class = "form-control", rows = 4, required = "required" })
                                    @Html.ValidationMessageFor(model => model.description, "", new { @class = "text-danger" })
                                </td>
                            </tr>
                            <tr>
                                <th>Location</th>
                                <td>
                                    @Html.EditorFor(model => model.location, new { htmlAttributes = new { @class = "form-control", required = "required" } })
                                    @Html.ValidationMessageFor(model => model.location, "", new { @class = "text-danger" })
                                </td>
                            </tr>
                            <tr>
                                <th>Priority</th>
                                <td>
                                    @Html.DropDownListFor(model => model.PriorityId, ViewBag.PriorityId as SelectList, "-- Select Priority --", new { @class = "form-control", required = "required" })
                                    @Html.ValidationMessageFor(model => model.PriorityId, "", new { @class = "text-danger" })
                                </td>
                            </tr>
                            <tr>
                                <th>Repaired Status</th>
                                <td>
                                    @Html.DropDownListFor(model => model.Repaired_StausId, ViewBag.Repaired_StausId as SelectList, "-- Select Repaired Status --", new { @class = "form-control", required = "required" })
                                    @Html.ValidationMessageFor(model => model.Repaired_StausId, "", new { @class = "text-danger" })
                                </td>
                            </tr>
                            <tr>
                                <th>Image</th>
                                <td>
                                    <input type="file" name="ImageData" class="form-control-file" required="required" />
                                    @Html.ValidationMessageFor(model => model.image_data, "", new { @class = "text-danger", required = "required" })
                                </td>
                            </tr>
                            <tr>
                                <th>Action_Date</th>
                                <td>
                                    @Html.EditorFor(model => model.action_date, new { htmlAttributes = new { @class = "form-control", required = "required" } })
                                    @Html.ValidationMessageFor(model => model.action_date, "", new { @class = "text-danger" })
                                </td>
                            </tr>
                        </tbody>
                    </table>

                    <div class="form-group">
                        <input type="submit" value="Create" class="btn btn-primary" />
                    </div>
                }
            </div>
        </div>
    </div>

    <div class="container mt-3">
        @Html.ActionLink("Back to List", "Index", null, new { @class = "btn btn-secondary" })
    </div>

    <!-- Include Bootstrap's JavaScript at the end of the page (before the closing </body> tag) if needed -->
    <!-- <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js" integrity="sha384-B4gt1jrGC7Jh4AgTPSdUtOBvfO8sh+WyqDz5SvLmbehY4p6o7aS7iC5f1l/2kCS" crossorigin="anonymous"></script> -->
</body>
</html>

Views/StudentComplains/Details.cshtml
@model LabMaintanance6.Models.Complain

@{
    ViewBag.Title = "Details";
    Layout = "~/Views/Shared/User_layout.cshtml";
}

<!-- Include the slick CSS file -->
<link rel="stylesheet" type="text/css" href="https://cdnjs.cloudflare.com/ajax/libs/slick-carousel/1.8.1/slick.min.css" />

<style>
    .complain-image {
        width: 300px; /* Set the initial width of the image */
        height: auto; /* Maintain the aspect ratio */
        cursor: pointer; /* Add cursor pointer to indicate it's clickable */
    }
</style>

<h2>Complain Details</h2>

<div class="table-responsive">
    <table class="table table-bordered">
        <tbody>
            <tr>
                <th class="table-label">
                    Name Of the Item
                </th>
                <td class="table-value">
                    @Html.DisplayFor(model => model.Name_Of_the_Item)
                </td>
            </tr>
            <tr>
                <th class="table-label">
                    Description
                </th>
                <td class="table-value">
                    @Html.DisplayFor(model => model.description)
                </td>
            </tr>
            <tr>
                <th class="table-label">
                    Location
                </th>
                <td class="table-value">
                    @Html.DisplayFor(model => model.location)
                </td>
            </tr>
            <tr>
                <th class="table-label">
                    <strong>Image:</strong>
                </th>
                <td>
                    @if (Model.image_data != null)
                    {
                        var base64Image = Convert.ToBase64String(Model.image_data);
                        var imgSrc = $"data:image;base64,{base64Image}";
                        <img src="@imgSrc" alt="Complain Image" class="complain-image img-fluid" />
                    }
                </td>
            </tr>
      
         
            <tr>
                <th class="table-label">
                    Priority
                </th>
                <td class="table-value">
                    @Html.DisplayFor(model => model.Priority.priority1)
                </td>
            </tr>
            <tr>
                <th class="table-label">
                    Repaired Staus
                </th>
                <td class="table-value">
                    @Html.DisplayFor(model => model.Repaired_Staus.R_Status)
                </td>
            </tr>
        </tbody>
    </table>
</div>

<!-- Include the jQuery and slick JavaScript files -->
<script src="https://code.jquery.com/jquery-3.6.0.min.js"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/slick-carousel/1.8.1/slick.min.js"></script>

<script>
    $(document).ready(function () {
        // Initialize the image slider
        $('.complain-image-slider').slick({
            dots: true, // Show navigation dots
            arrows: true, // Show navigation arrows
            draggable: true, // Enable dragging to slide
            infinite: true, // Enable infinite loop
            slidesToShow: 1, // Show one slide at a time
            slidesToScroll: 1, // Scroll one slide at a time
            prevArrow: '<button type="button" class="slick-prev"><i class="fas fa-chevron-left"></i></button>', // Custom previous arrow
            nextArrow: '<button type="button" class="slick-next"><i class="fas fa-chevron-right"></i></button>' // Custom next arrow
        });

        // Open the image slider when clicking on the small image
        $('.complain-image').on('click', function () {
            var imgSrc = $(this).attr('src');
            $('#modalImage').attr('src', imgSrc);
            $('#imageModal').modal('show');
        });
    });
</script>

<!-- Image Modal -->
<div class="modal fade" id="imageModal" tabindex="-1" role="dialog" aria-labelledby="imageModalLabel" aria-hidden="true">
    <div class="modal-dialog modal-dialog-centered" role="document">
        <div class="modal-content">
            <div class="modal-body">
                <div class="complain-image-slider">
                    @if (Model.image_data != null)
                    {
                        var base64Image = Convert.ToBase64String(Model.image_data);
                        var imgSrc = $"data:image;base64,{base64Image}";
                        <div class="slide">
                            <img src="@imgSrc" alt="Complain Image" class="complain-image" />
                        </div>
                    }
                </div>
            </div>
        </div>
    </div>
</div>

<div class="action-links">
   
   
    @Html.ActionLink("Back to List", "Index", null, new { @class = "btn btn-secondary" })
</div>

Views/StudentComplains/Index.cshtml
@model IPagedList<LabMaintanance6.Models.Complain>

@{
    ViewBag.Title = "Index";
    Layout = "~/Views/Shared/User_layout.cshtml";
}
@using PagedList;
@using PagedList.Mvc;

<h2 class="text-center">Complain List</h2>

<p class="text-center">
    @Html.ActionLink("Submit New Complain", "Create", null, new { @class = "btn btn-primary" })
</p>
<div class="container-fluid">
    <!-- Breadcrumbs-->
    <div class="card mb-3">
        <div class="row justify-content-end">
            
        </div>

        <br />
        <br />
        <br />
        <div class="card-body">
            <div class="table-responsive">
                <table class="table table-condensed table-hover table-bordered table-striped table" id="dataTable" width="100%" cellspacing="0">
                    <thead>

                        <tr>
                            <th>Get Details</th>
                            <th>Image</th>
                            <th>Name_of_the_Item</th>
                            <th>Repaired_Staus</th>
                            <th>Location</th>
                            <th>Priority</th>
                            <th>Description</th>

                            <th>Date</th>
                         
                        </tr>
                    </thead>
                    <tbody>
                        @foreach (var item in Model) // Display only ten most recent rows in reverse order
                        {
                            <tr>
                                <td>
                                    @Html.ActionLink("Details", "Details", new { id = item.complain_id }, new { @class = "btn btn-info btn-action" })



                                </td>
                                <td>
                                    @if (item.image_data != null)
                                    {
                                        var base64Image = Convert.ToBase64String(item.image_data);
                                        var imgSrc = $"data:image;base64,{base64Image}";
                                        <img src="@imgSrc" alt="Complain Image" class="img-fluid" />
                                    }
                                </td>
                                <td>
                                    <span>@Html.DisplayFor(modelItem => item.Name_Of_the_Item)</span>
                                </td>
                                <td>
                                    @Html.DisplayFor(modelItem => item.Repaired_Staus.R_Status)
                                </td>
                                <td>
                                    @Html.DisplayFor(modelItem => item.location)
                                </td>
                                <td>
                                    @Html.DisplayFor(modelItem => item.Priority.priority1)
                                </td>
                                <td>
                                    <span>@Html.DisplayFor(modelItem => item.description)</span>
                                </td>

                                <td>@Html.DisplayFor(modelItem => item.action_date)</td>


                            </tr>
                            
                        }

                    </tbody>
                </table>
                @Html.PagedListPager(Model, i => Url.Action("Index", "StudentComplains", new { i, search = Request.QueryString["search"] }))
            </div>
        </div>
    </div>
    
    </div>